
#ifndef  _FILE_H_
#define  _FILE_H_


#include  <fcntl.h>
#include  <limits.h>

#include  <gromada/types.h>


#ifndef  O_BINARY
  #define  O_BINARY  0x8000
#endif

#define  F_READ_ONLY   (O_RDONLY | O_BINARY)
#define  F_WRITE_ONLY  (O_WRONLY | O_BINARY)
#define  F_READ_WRITE  (O_RDWR | O_BINARY)
#define  F_CREATE      (O_WRONLY | O_CREAT | O_TRUNC | O_BINARY)
#define  F_APPEND      (O_WRONLY | O_APPEND | O_BINARY)


typedef struct {
  int   handle;
  int   accessMode;
  char  filename[PATH_MAX];
} FHandle;

typedef  Int64  FOffset;


FHandle  *f_open  (const char *filename,  int accessMode);
int      f_read   (FHandle *fh,  Pointer  buffer,  Uint sizeBytes);
int      f_write  (FHandle *fh,  Pointer  buffer,  Uint sizeBytes);
int      f_seek   (FHandle *fh,  Int64 offset,  int whence);
Int64    f_tell   (FHandle *fh);
void     f_close  (FHandle *fh);


#endif  // _FILE_H_
